> ## Documentation Index
> Fetch the complete documentation index at: https://developer.rocket.chat/llms.txt
> Use this file to discover all available pages before exploring further.

# Get List of Integrations

> Any of the following permissions is required:
* `manage-incoming-integrations`
* `manage-own-incoming-integrations`
* `manage-outgoing-integrations`
* `manage-own-outgoing-integrations`

The endpoint returns the integrations based on the user permissions.
### Changelog
| Version      | Description | 
| ---------------- | ------------|
|7.0.0            | Added `name` and `type` query parameters for filtering.       |
|1.1.0            | Separate permissions in incoming and outgoing.       |
|0.49.0            | Added       |

## OpenAPI

````json GET /api/v1/integrations.list
{
  "openapi": "3.0.0",
  "info": {
    "version": "1.0.0",
    "title": "Integrations"
  },
  "servers": [
    {
      "url": "https://apiexplorer.support.rocket.chat"
    }
  ],
  "paths": {
    "/api/v1/integrations.list": {
      "get": {
        "tags": [
          "Integration"
        ],
        "summary": "Get List of Integrations",
        "description": "Any of the following permissions is required:\n* `manage-incoming-integrations`\n* `manage-own-incoming-integrations`\n* `manage-outgoing-integrations`\n* `manage-own-outgoing-integrations`\n\nThe endpoint returns the integrations based on the user permissions.\n### Changelog\n| Version      | Description | \n| ---------------- | ------------|\n|7.0.0            | Added `name` and `type` query parameters for filtering.       |\n|1.1.0            | Separate permissions in incoming and outgoing.       |\n|0.49.0            | Added       |",
        "operationId": "get-api-v1-integrations-list",
        "parameters": [
          {
            "$ref": "#/components/parameters/X-Auth-Token"
          },
          {
            "$ref": "#/components/parameters/X-User-Id"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "$ref": "#/components/parameters/count"
          },
          {
            "$ref": "#/components/parameters/query"
          },
          {
            "$ref": "#/components/parameters/fields"
          },
          {
            "name": "name",
            "in": "query",
            "description": "Filter list by the name of the integration.",
            "schema": {
              "type": "string"
            },
            "example": "test"
          },
          {
            "name": "type",
            "in": "query",
            "description": "Filter list by the type of the integration. It can be `webhook-outgoing` or `webhook-incoming`.",
            "schema": {
              "type": "string"
            },
            "example": "webhook-incoming"
          },
          {
            "schema": {},
            "in": "query",
            "name": "sort",
            "description": "Sort the results in ascending (`1`) or descending order (`-1`). By default, the results are sorted in descending order of timestamp (`{\"ts\": -1}`). The additional options for the sort parameter are:\n * `name`: Sort by the integration name. `sort={\"name\": 1}` or `sort={\"name\": -1}`\n * `channel`: Sort by target channel. `sort={\"channel\": 1}` or `sort={\"channel\": -1}`\n * `_createdAt`: Sort by date of creation. `sort={\"_createdAt\": 1}` or `sort={\"_createdAt\": -1}`\n * `_createdBy`: Sort by user who created the integration. `sort={\"_createdBy\": 1}` or `sort={\"_createdBy\": -1}`\n * `username`: Sort by the value in the \"post-as\" username field. `sort={\"username\": 1}` or `sort={\"username\": -1}`\n * You can also use multiple options for one sort query. For example, `sort={\"_createdAt\": -1, \"name\": 1}`. This sorts by creation date in descending order, then by name in ascending order."
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "integrations": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "properties": {
                          "_id": {
                            "type": "string"
                          },
                          "enabled": {
                            "type": "boolean"
                          },
                          "username": {
                            "type": "string"
                          },
                          "alias": {
                            "type": "string"
                          },
                          "avatar": {
                            "type": "string"
                          },
                          "name": {
                            "type": "string"
                          },
                          "triggerWords": {
                            "type": "array",
                            "items": {
                              "type": "string"
                            }
                          },
                          "urls": {
                            "type": "array",
                            "items": {
                              "type": "string"
                            }
                          },
                          "token": {
                            "type": "string"
                          },
                          "script": {
                            "type": "string"
                          },
                          "scriptEnabled": {
                            "type": "boolean"
                          },
                          "impersonateUser": {
                            "type": "boolean"
                          },
                          "scriptCompiled": {
                            "type": "string"
                          },
                          "scriptError": {
                            "type": "string"
                          },
                          "type": {
                            "type": "string"
                          },
                          "userId": {
                            "type": "string"
                          },
                          "channel": {
                            "type": "array",
                            "items": {
                              "type": "object"
                            }
                          },
                          "_createdAt": {
                            "type": "string"
                          },
                          "_createdBy": {
                            "type": "object",
                            "properties": {
                              "username": {
                                "type": "string"
                              },
                              "_id": {
                                "type": "string"
                              }
                            }
                          },
                          "_updatedAt": {
                            "type": "string"
                          }
                        }
                      }
                    },
                    "offset": {
                      "type": "integer"
                    },
                    "items": {
                      "type": "integer"
                    },
                    "total": {
                      "type": "integer"
                    },
                    "success": {
                      "type": "boolean"
                    }
                  }
                },
                "examples": {
                  "Success Example": {
                    "value": {
                      "integrations": [
                        {
                          "_id": "WMQDChpnYTRmFre9h",
                          "enabled": "true",
                          "username": "rocket.cat",
                          "alias": "Guggy",
                          "avatar": "https://image.crisp.im/avatar/website/17651a90-e082-43f6-b308-957cea6e323c/128",
                          "name": "Guggy",
                          "triggerWords": [
                            "!guggy",
                            "guggy",
                            "gif+"
                          ],
                          "urls": [
                            "http://text2gif.guggy.com/guggify"
                          ],
                          "token": "aobEdbYhXfu5hkeqG",
                          "script": "...",
                          "scriptEnabled": "true",
                          "impersonateUser": "false",
                          "scriptCompiled": "...",
                          "scriptError": null,
                          "type": "webhook-outgoing",
                          "userId": "rocket.cat",
                          "channel": [],
                          "_createdAt": "2017-01-05T17:06:05.66Z",
                          "_createdBy": {
                            "username": "graywolf336",
                            "_id": "R4jgcQaQhvvK6K3iY"
                          },
                          "_updatedAt": "2017-01-05T17:06:05.66Z"
                        },
                        {
                          "_id": "3aazpZ2WzoBP8msi9",
                          "type": "webhook-outgoing",
                          "name": "Testing via REST API",
                          "enabled": "false",
                          "username": "rocket.cat",
                          "urls": [
                            "http://text2gif.guggy.com/guggify"
                          ],
                          "scriptEnabled": "false",
                          "userId": "rocket.cat",
                          "channel": [],
                          "_createdAt": "2017-01-06T13:23:46.018Z",
                          "_createdBy": {
                            "username": "graywolf336",
                            "_id": "R4jgcQaQhvvK6K3iY"
                          },
                          "_updatedAt": "2017-01-06T13:23:46.018Z"
                        }
                      ],
                      "offset": "0",
                      "items": "2",
                      "total": "2",
                      "success": "true"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/authorizationError"
          }
        }
      }
    }
  },
  "components": {
    "parameters": {
      "X-Auth-Token": {
        "name": "X-Auth-Token",
        "in": "header",
        "description": "The authorization token of the user.",
        "required": "true",
        "schema": {
          "type": "string"
        },
        "example": "9HqLlyZOugD_0YdwAJF8V47U3QHXSq"
      },
      "X-User-Id": {
        "name": "X-User-Id",
        "in": "header",
        "description": "The user ID of the user.",
        "required": "true",
        "schema": {
          "type": "string"
        },
        "example": "aobEdbYhXfu5hkeqG"
      },
      "offset": {
        "name": "offset",
        "in": "query",
        "description": "Number of items to \"skip\" in the query, i.e. requests return count items, skipping the first offset items. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#pagination) to learn more.",
        "required": "false",
        "schema": {
          "type": "integer"
        },
        "example": "50"
      },
      "count": {
        "name": "count",
        "in": "query",
        "description": "The number of items to return. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#pagination) to learn more.",
        "required": "false",
        "schema": {
          "type": "integer"
        },
        "example": "50"
      },
      "query": {
        "name": "query",
        "in": "query",
        "description": "This parameter allows you to use MongoDB query operators to search for specific data. For example, to query users with a name that contains the letter \"g\": query=`{ \"name\": { \"$regex\": \"g\" } }`. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#query-and-fields) to learn more.",
        "required": "false",
        "schema": {}
      },
      "fields": {
        "name": "fields",
        "in": "query",
        "description": "This parameter accepts a JSON object with properties that have a value of 1 or 0 to include or exclude them in the response. For example, to only retrieve the usernames of users: fields=`{ \"username\": 1 }`. Refer to the [official documentation](https://developer.rocket.chat/apidocs/query-parameters#query-and-fields) to learn more.",
        "required": "false",
        "schema": {
          "type": "string"
        }
      }
    },
    "responses": {
      "authorizationError": {
        "description": "Unauthorized",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "status": {
                  "type": "string"
                },
                "message": {
                  "type": "string"
                }
              }
            },
            "examples": {
              "Authorization Error": {
                "value": {
                  "status": "error",
                  "message": "You must be logged in to do this."
                }
              }
            }
          }
        }
      }
    }
  }
}
````

